/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package data;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.text.DateFormat;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.logging.Level;
import java.util.logging.Logger;
import server.Operation;

import java.io.InputStreamReader;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Tool {
	/**
	 * ĳļм¼
	 * 
	 * @param FILEPATH
	 * @param filename
	 * @return
	 */
	public static int readToLines(String FILEPATH, String filename) {
		int n = 0;
		String lineString = "";
		try {
			// System.out.println("ļ"+filename);
			File file = new File(FILEPATH + filename);
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			while ((lineString = br.readLine()) != null) {
				n++;
			}
			fr.close();
			br.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return n;
	}

	/**
	 * õǰ
	 * 
	 * @return
	 */
	public static String getTime() {
		Date now = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		return sdf.format(now);

	}

	public static String getTimes() {
		Date now = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		return sdf.format(now);

	}

	/**
	 * 
	 * 
	 * @param hangBanHao
	 * @return
	 */
	public static String getDingDanID(String hangBanHao) {
		int countDingDan = readToLines("./booking_record/", "booking.txt");
		String count = "0";
		if (countDingDan < 10) {
			count = count + count + count + countDingDan;
		} else if (countDingDan < 1000) {
			count = count + count + countDingDan;
		} else if (countDingDan < 10000) {
			return (hangBanHao + Tool.getTime() + countDingDan);
		} else {
			countDingDan = 0;
			count = count + count + count + countDingDan;
		}
		return (hangBanHao + Tool.getTime() + count);
	}

	/**
	 * طʱΪȨֵ
	 * 
	 * @param startTime
	 * @param endTime
	 * @return
	 */
	public static long getPlayTime(String startTime, String endTime) {
		long timeLen = 0;
		DateFormat df = new SimpleDateFormat("HH:mm:ss");
		try {

			Date d1 = df.parse(endTime);
			Date d2 = df.parse(startTime);
			long diff = d1.getTime() - d2.getTime();
			long days = diff / (1000 * 60);
			timeLen = days;
		} catch (Exception e) {
		}
		return timeLen;
	}

	/**
	 * жϵļǷڣ
	 * 
	 * @param file
	 * @return
	 */
	public static boolean judeFileExists(File file) {

		if (file.exists()) {
			return true;
		} else {
			try {
				file.createNewFile();
			} catch (IOException ex) {
				Logger.getLogger(Operation.class.getName()).log(Level.SEVERE, null, ex);
			}
			return false;
		}
	}

	/**
	 * жļǷļ
	 * 
	 * @param path
	 * @return
	 */
	public static boolean testDir(String path) {
		File f = new File(path);
		if (f.exists()) {

			// System.out.println("ļдļ");
			return true;
		} else {
			// System.out.println("ļвļ");
			return false;
		}
	}

	/**
	 * ȡnǰ
	 * 
	 * @param n
	 * @return
	 */
	public static String getBeforetime(int n) {
		Date now = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		return sdf.format(new Date(now.getTime() - n * 24 * 60 * 60 * 1000));
	}

	/**
	 * ȡn
	 * 
	 * @param n
	 * @return
	 */
	public static String getAftertime(int n) {
		Date now = new Date();
		GregorianCalendar gc = new GregorianCalendar();
		gc.setTime(new Date());
		gc.add(5, n);
		gc.set(gc.get(Calendar.YEAR), gc.get(Calendar.MONTH), gc.get(Calendar.DATE));
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		return sdf.format(gc.getTime());
		// ʹDataмʱ׳
		// return sdf.format(new Date(now.getTime() + n*24 * 60 * 60 * 1000));
	}

	/**
	 * ɾĳ·µļ
	 * 
	 * @param fileName
	 */
	public static void deleteFile(String fileName) {
		File file = new File(fileName);
		// ļ·Ӧļڣһļֱɾ
		if (file.exists() && file.isFile()) {
			// ˴Ӧ쳣Ҳ봦
			file.delete();
			// System.out.println("ɾļ" + fileName + "ɹ");

		} else {
			// System.out.println("ɾļʧܣ" + fileName + "ڣ");
			System.out.println("ɾļ쳣");
		}
	}

	public static void deleteFiles(String fileName) {
		File file = new File(fileName);
		// ļ·Ӧļڣһļֱɾ
		if (file.exists()) {
			// ˴Ӧ쳣Ҳ봦
			file.delete();
			System.out.println("ɾļ" + fileName + "ɹ");

		} else {
			// System.out.println("ɾļʧܣ" + fileName + "ڣ");
			System.out.println("ɾļ쳣");
		}
	}

	public static void recurDelete(File f) {
		for (File fi : f.listFiles()) {
			if (fi.isDirectory()) {
				recurDelete(fi);
			} else {
				fi.delete();
			}
		}
		f.delete();
	}

	/**
	 * file1 еļfile2 ļ 
	 * copy("./flight_information/flight_record.txt","./month_flight_information");
	 * 
	 * @param file1
	 * @param file2
	 */
	public static void copy(String file1, String file2) {

		System.out.println(file1);
		System.out.println(file2);
		File src = new File(file1);
		File dst = new File(file2);
		if (!dst.exists()) {
			dst.mkdirs();
		}
		InputStream in = null;
		OutputStream out = null;
		// System.out.println(file1.substring(file1.lastIndexOf("/"),file1.length()));//ȡļԴļ
		try {
			in = new BufferedInputStream(new FileInputStream(src), 16 * 1024);
			FileOutputStream f = new FileOutputStream(dst + file1.substring(file1.lastIndexOf("/"), file1.length()));// һҪļ
			out = new BufferedOutputStream(f, 16 * 1024);
			byte[] buffer = new byte[16 * 1024];
			int len = 0;
			while ((len = in.read(buffer)) > 0) {
				out.write(buffer, 0, len);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (null != in) {
				try {
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (null != out) {
				try {
					out.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	/**
	 * Path·µoldnameļΪnewname
	 * 
	 * @param Path
	 * @param oldname
	 * @param newname
	 */
	public static void renameFile(String Path, String oldname, String newname) {
		if (!oldname.equals(newname)) {// µļǰļͬʱ,бҪ
			File oldfile = new File(Path + "/" + oldname);
			File newfile = new File(Path + "/" + newname);
			if (!oldfile.exists()) {
				return;// ļ
			}
			if (newfile.exists())// ڸĿ¼Ѿһļļͬ
				System.out.println(newname + "Ѿڣ");
			else {
				oldfile.renameTo(newfile);
			}
		} else {
			System.out.println("ļ;ļͬ...");
		}
	}

	/**
	 * ļм·Ƿڣ򴴽ļ
	 * 
	 * @param FILEPATH
	 * @param filename
	 */
	public static void checkFile(String FILEPATH, String filename) {
		File file = new File(FILEPATH + filename);

		File fileDir = new File(FILEPATH);
		file = new File(FILEPATH + filename);
		if (!fileDir.exists()) {
			fileDir.mkdirs();
		}
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * ж֤Ƿϸʽ
	 * 
	 * @param idCard
	 * @return
	 */
	public static boolean checkID(String idCard) {
		/*
		 * BufferedReader consoleReader = new BufferedReader(new
		 * InputStreamReader(System.in)); String idNum=null; try { idNum=
		 * consoleReader.readLine(); } catch (IOException e) { e.printStackTrace(); }
		 */
		// бû֤ŵʽҪô15λҪô18λһλΪĸ
		Pattern idNumPattern = Pattern.compile("(\\d{14}[0-9a-zA-Z])|(\\d{17}[0-9a-zA-Z])");
		// ͨPatternMatcher
		Matcher idNumMatcher = idNumPattern.matcher(idCard);
		// жûǷΪ֤
		if (idNumMatcher.matches()) {
			return true;
		} else {
			// ǣϢʾû
			return false;
		}
	}

	public static boolean compare_date(String DATE1, String DATE2) {

		DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
		try {
			Date dt1 = df.parse(DATE1);
			Date dt2 = df.parse(DATE2);
			if (dt1.getTime() >= dt2.getTime()) {
				return true;
			} else if (dt1.getTime() < dt2.getTime()) {
				return false;
			}

		} catch (Exception exception) {
			exception.printStackTrace();
		}
		return false;
	}

}
